window.addEventListener('DOMContentLoaded', function () {
  var appendBody = document.body.appendChild.bind(document.body),
      installButton = document.createElement('button'),
      refreshButton = document.createElement('button'),
      origin = function origin () {
        var origin = window.location.origin;
        if (!origin) {
          origin = window.location.protocol + '//' + window.location.host;
        }
        return origin;
      };

  installButton.appendChild(document.createTextNode('Install'));
  installButton.onclick = function installOnClick () {
    var pending = navigator.mozApps.install(origin() + '/manifest.webapp');
    pending.onerror = function requestOnError () {
      installButton.innerHTML = 'Already installed';
      installButton.disabled = 'disabled';
    };
    pending.onsuccess = function requestOnSuccess () {
      console.log('App installed');
    };
  };

  refreshButton.appendChild(document.createTextNode('Refresh'));
  refreshButton.onclick = window.location.reload.bind(window.location, true);
  
  appendBody(document.createElement('hr'));
  appendBody(installButton);
  appendBody(refreshButton);
});